//https://www.msx.org/forum/development/msx-development/undocumented-mode-1-2-polldiscussion
//Control register #4:
//bit 7 - 3 : ignored
//bit 2 : PG13; if set, PG = 2000h otherwise 0
//bit 1 : if set, the last 8 rows use the 3rd pattern table otherwise 1st.
//bit 0 : if set, the middle 8 rows use the 2nd pattern table otherwise 1st.



#include <stdio.h>
#include <windows.h>   
#include "vsm.hpp"   

/********************************************************************/

class V9938 : public IACTIVEMODEL,public IDSIMMODEL 
{ 
public: 
  int isdigital (CHAR *pinname); 
  void setup (IINSTANCE *inst, IDSIMCKT *dsim); 
  void runctrl (RUNMODES mode); 
  void actuate (REALTIME time, ACTIVESTATE newstate); 
  BOOL indicate (REALTIME time, ACTIVEDATA *data); 
  void simulate (ABSTIME time, DSIMMODES mode); 
  void callback (ABSTIME time, EVENTID eventid); 
  void initialize (ICOMPONENT *cpt); 
  ISPICEMODEL *getspicemodel (CHAR *device); 
  IDSIMMODEL *getdsimmodel (CHAR *device); 
  void plot (ACTIVESTATE state); 
  void animate (INT element, ACTIVEDATA *newstate); 
  BOOL actuate (WORD key, INT x, INT y, DWORD flags); 
  unsigned char takt; //  ,       
  unsigned short clk_cnt;
  unsigned char line_cnt,ttt;  
  unsigned char cpuclk_cnt;  
  unsigned char dclk_cnt;  
  unsigned char T0tmp,T1tmp;
  unsigned char Palette[32];
  unsigned char Reg[64],SReg[16];
  unsigned char VRAM[0x20000];//128KB
  unsigned int VRAM_ptr;
  unsigned char char_line_cnt;
  unsigned char video_mode;
  unsigned short x_cnt,y_cnt;

private: 
 void print_mode(unsigned char mode);
 unsigned char get_data();
 void set_data(ABSTIME time,unsigned char tmp);
 void set_data_Z(ABSTIME time);
 void set_color(ABSTIME time,unsigned char tmp,unsigned char col);
 void set_colorG(ABSTIME time,unsigned char pal_tmp,unsigned char col);
 void Process_command(void);
 void Process_B0_cmd(void);
 void DrawPlot(unsigned short x, unsigned short y);
 void DrawLine(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2);
  IINSTANCE *instance;  
  IDSIMCKT *ckt;      
  ICOMPONENT *component;   
  IDSIMPIN *pin_CLK; 
  IDSIMPIN *pin_nRD; 
  IDSIMPIN *pin_nWR; 
  IDSIMPIN *pin_MODE0; 
  IDSIMPIN *pin_MODE1; 
  IDSIMPIN *pin_D0; 
  IDSIMPIN *pin_D1; 
  IDSIMPIN *pin_D2; 
  IDSIMPIN *pin_D3; 
  IDSIMPIN *pin_D4; 
  IDSIMPIN *pin_D5; 
  IDSIMPIN *pin_D6; 
  IDSIMPIN *pin_D7; 
  IDSIMPIN *pin_INT;
  IDSIMPIN *pin_nRESET;
  IDSIMPIN *pin_CPUCLK;
  IDSIMPIN *pin_DHCLK;
  IDSIMPIN *pin_DLCLK;
  IDSIMPIN *pin_VIDEO;
  IDSIMPIN *pin_G;
  IDSIMPIN *pin_R;
  IDSIMPIN *pin_B;
  IDSIMPIN *pin_HRTC;
  IDSIMPIN *pin_VRTC;
}; 

HANDLE hProcessHeap;

extern "C" IDSIMMODEL __declspec(dllexport)*createdsimmodel(CHAR *device,ILICENCESERVER *ils)   {     
        ils->authorize(0x88888888, 0x69);  
        return new V9938;   
}   

extern "C" VOID __declspec(dllexport)deletedsimmodel(IDSIMMODEL*model)   {   
    delete (V9938*)model; 
}   
       
int V9938::isdigital(CHAR *pinname)   {   
        return 1;   
}   

/********************************************************************/

void V9938::setup(IINSTANCE *inst,IDSIMCKT *dsim)   {   
    instance = inst;    
          ckt = dsim;     
        
    instance->log("v9938.dll - Version 6");
    hProcessHeap=GetProcessHeap();
  ttt=0;
  takt=0;
  clk_cnt=0;
  line_cnt=0;
  cpuclk_cnt=0;
  dclk_cnt=0;
  VRAM_ptr=0;
  SReg[0]=0;
  SReg[2]=0x80;
  char_line_cnt=0;
  video_mode=0x01;
  Reg[1]=0x10;
  Reg[7]=0x00;
  Reg[9]=0;
  Reg[23]=0;
  x_cnt=0;
  y_cnt=0;

    pin_DHCLK = instance->getdsimpin("$DHCLK$", true); pin_DHCLK->setstate(0,1,FLT);
    pin_DLCLK = instance->getdsimpin("$DLCLK$", true); pin_DLCLK->setstate(0,1,FLT);
    pin_CLK = instance->getdsimpin("XTAL1", true); pin_CLK->setstate(0,1,FLT);
    pin_nRD = instance->getdsimpin("$CSR$", true); pin_nRD->setstate(0,1,FLT);
    pin_nWR = instance->getdsimpin("$CSW$", true); pin_nWR->setstate(0,1,FLT);
    pin_MODE0 = instance->getdsimpin("MODE0", true);    pin_MODE0->setstate(0,1,FLT);
    pin_MODE1 = instance->getdsimpin("MODE1", true);    pin_MODE1->setstate(0,1,FLT);
    pin_D0 = instance->getdsimpin("CD0", true);
    pin_D1 = instance->getdsimpin("CD1", true);
    pin_D2 = instance->getdsimpin("CD2", true);
    pin_D3 = instance->getdsimpin("CD3", true);
    pin_D4 = instance->getdsimpin("CD4", true);
    pin_D5 = instance->getdsimpin("CD5", true);
    pin_D6 = instance->getdsimpin("CD6", true);
    pin_D7 = instance->getdsimpin("CD7", true);    set_data_Z(0);
    pin_INT = instance->getdsimpin("$INT$", true);    pin_INT->setstate(0,1,SHI);
    pin_nRESET = instance->getdsimpin("$RESET$", true); pin_nRESET->setstate(0,1,FLT);
    pin_CPUCLK = instance->getdsimpin("CPUCLK", true);  pin_CPUCLK->setstate(0,1,SLO);
    pin_VIDEO  = instance->getdsimpin("VIDEO", true);  pin_VIDEO->setstate(0,1,SLO);
    pin_G  = instance->getdsimpin("G", true);  pin_G->setstate(0,1,SLO);
    pin_R  = instance->getdsimpin("R", true);  pin_R->setstate(0,1,SLO);
    pin_B  = instance->getdsimpin("B", true);  pin_B->setstate(0,1,SLO);
    pin_HRTC  = instance->getdsimpin("HSYNC", true);   pin_HRTC->setstate(0,1,SLO);
    pin_VRTC  = instance->getdsimpin("CSYNC", true);   pin_VRTC->setstate(0,1,SLO);
}   
       
void V9938::runctrl(RUNMODES mode)  {   

}   
       
       
void V9938::actuate(REALTIME time,ACTIVESTATE newstate) {   

}   
       
BOOL V9938::indicate(REALTIME time,ACTIVEDATA *data)   {      
  return TRUE;
}   
//    Z       
void V9938::set_data_Z(ABSTIME time)
{
 pin_D0->setstate(time,1,FLT);   
 pin_D1->setstate(time,1,FLT);   
 pin_D2->setstate(time,1,FLT);   
 pin_D3->setstate(time,1,FLT);   
 pin_D4->setstate(time,1,FLT);   
 pin_D5->setstate(time,1,FLT);   
 pin_D6->setstate(time,1,FLT);   
 pin_D7->setstate(time,1,FLT);   
}
//    
unsigned char V9938::get_data()
{
unsigned char tmp=0;
 if (ishigh(pin_D0->istate())) tmp|=0x01;
 if (ishigh(pin_D1->istate())) tmp|=0x02;
 if (ishigh(pin_D2->istate())) tmp|=0x04;
 if (ishigh(pin_D3->istate())) tmp|=0x08;
 if (ishigh(pin_D4->istate())) tmp|=0x10;
 if (ishigh(pin_D5->istate())) tmp|=0x20;
 if (ishigh(pin_D6->istate())) tmp|=0x40;
 if (ishigh(pin_D7->istate())) tmp|=0x80;
 return tmp;
}
//   
void V9938::set_data(ABSTIME time,unsigned char tmp)
{
  if (tmp&0x01) pin_D0->setstate(time,1,SHI); else pin_D0->setstate(time,1,SLO);
  if (tmp&0x02) pin_D1->setstate(time,1,SHI); else pin_D1->setstate(time,1,SLO);
  if (tmp&0x04) pin_D2->setstate(time,1,SHI); else pin_D2->setstate(time,1,SLO);
  if (tmp&0x08) pin_D3->setstate(time,1,SHI); else pin_D3->setstate(time,1,SLO);
  if (tmp&0x10) pin_D4->setstate(time,1,SHI); else pin_D4->setstate(time,1,SLO);
  if (tmp&0x20) pin_D5->setstate(time,1,SHI); else pin_D5->setstate(time,1,SLO);
  if (tmp&0x40) pin_D6->setstate(time,1,SHI); else pin_D6->setstate(time,1,SLO);
  if (tmp&0x80) pin_D7->setstate(time,1,SHI); else pin_D7->setstate(time,1,SLO);
}
void V9938::set_colorG(ABSTIME time,unsigned char pal_tmp,unsigned char col)
{
  unsigned char cl_R_B,cl_0_G;
  switch(pal_tmp)
  {
   case 0:
    cl_R_B=Palette[(col/64)*2];
    cl_0_G=Palette[((col/64)*2)+1];
    break;
   case 1:
    cl_R_B=Palette[(col&0x30)/8];
    cl_0_G=Palette[((col&0x30)/8)+1];
    break;
   case 2:
    cl_R_B=Palette[(col&0x0c)/2];
    cl_0_G=Palette[((col&0x0c)/2)+1];
    break;
   case 3:
    cl_R_B=Palette[(col&0x03)*2];
    cl_0_G=Palette[((col&0x03)*2)+1];
    break;
  }
//if ((col)!=0) instance->log("col %x  RB%x  G%x",col,cl_R_B,cl_0_G);
  if (cl_R_B&0xC0) pin_R->setstate(time,1,SHI); else pin_R->setstate(time,1,SLO);
  if (cl_R_B&0x0C) pin_B->setstate(time,1,SHI); else pin_B->setstate(time,1,SLO);
  if (cl_0_G&0x0C) pin_G->setstate(time,1,SHI); else pin_G->setstate(time,1,SLO);
  if (((cl_0_G&0x0f)==0x0f)|((cl_R_B&0x0f)==0x0f)|((cl_R_B&0xf0)==0xf0)) pin_VIDEO->setstate(time,1,SHI); else pin_VIDEO->setstate(time,1,SLO);

}
void V9938::set_color(ABSTIME time,unsigned char tmp,unsigned char col)
{
  unsigned char color[17]={0,0,8,9,2,3,7,0xa,4,5,0xc,0xd,6,0xb,0xe,0xf};
  if (tmp)
    tmp=color[col/16];
  else
    tmp=color[col&0x0f];
  if (tmp&0x01) pin_VIDEO->setstate(time,1,SHI); else pin_VIDEO->setstate(time,1,SLO);
  if (tmp&0x02) pin_B->setstate(time,1,SHI); else pin_B->setstate(time,1,SLO);
  if (tmp&0x04) pin_R->setstate(time,1,SHI); else pin_R->setstate(time,1,SLO);
  if (tmp&0x08) pin_G->setstate(time,1,SHI); else pin_G->setstate(time,1,SLO);
}
void V9938::print_mode(unsigned char mode)
{
        switch(mode)
        {
        case 0:
            instance->log("set video M0=Graphics I mode"); 
          break;
        case 0x01:
          instance->log("set video M1=Text mode");
          break;
        case 0x02:
          instance->log("set videi M2=Multicolor mode");
          break;
        case 0x04:
          instance->log("set video M3=Graphics II mode");
          break;
        case 0x08:
          instance->log("set video M4=Graphics III mode");
          break;
        case 0x09:
          instance->log("set video M1+M4=Text II mode");
          break;
        case 0x0c:
          instance->log("set video M3+M4=Graphics IV mode");
          break;
        case 0x10:
          instance->log("set video M5=Graphics V mode");
          break;
        case 0x14:
          instance->log("set video M3+M5=Graphics VI mode");
          break;
        case 0x1c:
          instance->log("set video M3+M4+M5=Graphics VII mode");
          break;
        }
}
void V9938::DrawPlot(unsigned short x, unsigned short y)
{
unsigned short ch_pn;
unsigned char tmp;
   if (video_mode==0x10)
   {
    ch_pn=x/4+128*y;
    tmp=VRAM[((Reg[2]/32)&0x03)*0x2000+ch_pn];
//instance->log("x %d y %d",x,y); 
    switch(x%4)
    {
     case 0:
     if (Reg[44]&0x02) tmp|=0x80; else tmp&=~0x80;
     if (Reg[44]&0x01) tmp|=0x40; else tmp&=~0x40;
     break;
     case 1:
     if (Reg[44]&0x02) tmp|=0x20; else tmp&=~0x20;
     if (Reg[44]&0x01) tmp|=0x10; else tmp&=~0x10;
     break;
     case 2:
     if (Reg[44]&0x02) tmp|=0x08; else tmp&=~0x08;
     if (Reg[44]&0x01) tmp|=0x04; else tmp&=~0x04;
     break;
     case 3:
     if (Reg[44]&0x02) tmp|=0x02; else tmp&=~0x02;
     if (Reg[44]&0x01) tmp|=0x01; else tmp&=~0x01;
     break;
    }
    VRAM[((Reg[2]/32)&0x03)*0x2000+ch_pn]=tmp;
   }  
}
void V9938::DrawLine(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2)
{
unsigned short deltaX = abs(x2 - x1);
unsigned short deltaY = abs(y2 - y1);
char signX = x1 < x2 ? 1 : -1;
char signY = y1 < y2 ? 1 : -1;
    //
    short error = deltaX - deltaY;
    //
    DrawPlot(x2, y2);
    while((x1 != x2) | (y1 != y2)) 
   {
        DrawPlot(x1, y1);
        short error2 = error * 2;
        //
        if(error2 > -deltaY) 
        {
            error -= deltaY;
            x1 += signX;
        }
        if(error2 < deltaX) 
        {
            error += deltaX;
            y1 += signY;
        }
    }
}

void V9938::Process_command(void)
{
//unsigned short tmp,tmp1,ch_pn;
//instance->log("set cmd log %x",Reg[46]&0x0f); 
switch(Reg[46]&0xf0)
 {
 case 0xf0:
  instance->log("set cmd HMMC ----"); 
  break;
 case 0xe0:
  instance->log("set cmd YMMM ----"); 
  break;
 case 0xd0:
  instance->log("set cmd HMMM ----"); 
  break;
 case 0xc0:
  instance->log("set cmd HMMV ----"); 
  break;
 case 0xb0:
  //instance->log("set cmd mov CPU->VDP");
  x_cnt=0;y_cnt=0;
  break;
 case 0xa0:
  instance->log("set cmd LMCM ----"); 
  break;
 case 0x90:
  instance->log("set cmd LMMM ----"); 
  break;
 case 0x80:
  instance->log("set cmd LMMV ----"); 
  break;
 case 0x70:
//  instance->log("set cmd LINE (%d,%d)-(%d,%d), col %d",(Reg[37]&0x01)*256+Reg[36], (Reg[39]&0x03)*256+Reg[38], (Reg[41]&0x01)*256+Reg[40], (Reg[42]&0x01)*256+Reg[43],Reg[44]&0x03); 
  DrawLine((Reg[37]&0x01)*256+Reg[36], (Reg[39]&0x03)*256+Reg[38], (Reg[37]&0x01)*256+Reg[36]+(Reg[41]&0x01)*256+Reg[40], (Reg[39]&0x03)*256+Reg[38]+(Reg[42]&0x01)*256+Reg[43]);
  break;
 case 0x60:
  instance->log("set cmd SRCH ----"); 
  break;
 case 0x50:
//  instance->log("set cmd PSET (%d,%d), col %d",(Reg[37]&0x01)*256+Reg[36], (Reg[39]&0x03)*256+Reg[38],Reg[44]&0x03); 
//====Graphic Mode G5 9938 512x192(212)===============================================
   DrawPlot((Reg[37]&0x01)*256+Reg[36],(Reg[39]&0x03)*256+Reg[38]);
  break;
 case 0x40:
  instance->log("set cmd POINT ----"); 
  break;
 case 0x00:
  instance->log("set cmd STOP"); 
  break;
 default:
  instance->log("set cmd %x",(Reg[46]&0xf0)/16); 
  break;

 }
}
void V9938::Process_B0_cmd(void)
{
// instance->log("x_cnt  %d y_cnt %d",x_cnt,y_cnt);
   DrawPlot((Reg[37]&0x01)*256+Reg[36]+x_cnt,(Reg[39]&0x03)*256+Reg[38]+y_cnt);
   if ((x_cnt+1)!=((Reg[41]&0x01)*256+Reg[40])) x_cnt++; else {x_cnt=0; if ((y_cnt+1)!=((Reg[43]&0x03)*256+Reg[42])) y_cnt++;}
}

//   
void V9938::simulate (ABSTIME time,DSIMMODES mode) {      
unsigned short tmp1,ch_pn;
unsigned char tmp,mask[]={0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
if (pin_CLK->isnegedge())
  {
   if (clk_cnt==0) 
   { 
    line_cnt++;
    if ((line_cnt>(3+13-1))&(line_cnt<(3+13+53+192+49+1))) 
    {
     pin_HRTC->setstate(0,1,SLO); 
     SReg[2]&=~0x40;//Reset vertical retrace flag
    }
   }
//===TEXT Mode================================================
   if ((line_cnt>(3+13+53-1-20))&(line_cnt<(3+13+53+192-20))&(((clk_cnt-100)%4)==0)&(video_mode==1))
   if ((clk_cnt>(100-1))&(clk_cnt<(100+960)))
   {
    tmp=VRAM[(Reg[2]&0x0f)*0x400+((clk_cnt-100)/4)/6+40*((line_cnt-16-53+20)/8)];
    tmp=VRAM[(Reg[4]&0x07)*0x800+(line_cnt-16-53+20)%8+tmp*8];
    if ((Reg[1]&0x40)==0) tmp=0;// Blank screen
    set_color(time,tmp&mask[((clk_cnt-100)/4)%6],Reg[7]);
   } else    set_color(time,0,Reg[7]);
//====Graphic Mode===============================================
   if ((line_cnt>(3+13+53-1-20))&(line_cnt<(3+13+53+192-20))&(((clk_cnt-100)%4)==0)&((video_mode==0)|(video_mode==2)|(video_mode==4)))
   if ((clk_cnt>(100-1))&(clk_cnt<(100+1024)))
   {
    ch_pn=((clk_cnt-100)/4)/8+32*((line_cnt-16-53+20)/8);
    tmp1=VRAM[(Reg[2]&0x0f)*0x400+ch_pn];
    if (video_mode==0x00) tmp=VRAM[(Reg[4]&0x07)*0x800+(line_cnt-16-53+20)%8+tmp1*8];
     else
      tmp=VRAM[(((Reg[4]&0x07)/4))*0x2000+(ch_pn/256)*0x800+(line_cnt-16-53+20)%8+tmp1*8];

    if ((Reg[1]&0x40)==0) tmp=0;// Blank screen

    if (video_mode==0x00) set_color(time,tmp&mask[((clk_cnt-100)/4)%8],VRAM[Reg[3]*0x40+tmp1/8]);
     else
      set_color(time,tmp&mask[((clk_cnt-100)/4)%8],VRAM[(Reg[3]/128)*0x2000+(ch_pn/256)*0x800+(line_cnt-16-53+20)%8+tmp1*8]);
   } else    set_color(time,0,Reg[7]);
//====Graphic Mode 9938 512x192(212)===============================================
   if ((line_cnt>(3+13+53-1-20))&(line_cnt<(3+13+53+192-20+(Reg[9]/128)*20))&(((clk_cnt-100)%2)==0)&(video_mode==0x10))
   if ((clk_cnt>(100-1))&(clk_cnt<(100+1024)))
   {
    ch_pn=(clk_cnt-100)/8+128*((unsigned char)(line_cnt-16-53+20+Reg[23]));
    tmp=VRAM[((Reg[2]/32)&0x03)*0x2000+ch_pn];
//instance->log("ch_pn %d  %d",ch_pn,((clk_cnt-100)/2)%4);  }
    if ((Reg[1]&0x40)==0) tmp=0;// Blank screen
//if ((line_cnt-16-53+20)==122) instance->log("ln %d  %x",(line_cnt-16-53+20),tmp);
  set_colorG(time,((clk_cnt-100)/2)%4,tmp);
   } else    set_color(time,0,Reg[7]);
//===TEXT II Mode================================================
   if ((line_cnt>(3+13+53-1-20))&(line_cnt<(3+13+53+192-20+(Reg[9]/128)*20))&(((clk_cnt-100)%2)==0)&(video_mode==0x09))
   if ((clk_cnt>(100-1))&(clk_cnt<(100+960)))
   {
//if (line_cnt==(3+13+53-20)) ttt=1;
    tmp1=VRAM[((Reg[2]/4)&0x0f)*0x1000+((clk_cnt-100)/2)/6+80*((line_cnt-16-53+20)/8)];
    tmp=VRAM[(Reg[4]&0x1f)*0x800+(line_cnt-16-53+20)%8+tmp1*8];
//if (ttt) instance->log("line %d, tmp1{%c}[%x],tmpAdr %x",(line_cnt-16-53+20), tmp1,((Reg[2]/4)&0x0f)*0x1000+((clk_cnt-100)/2)/6+80*((line_cnt-16-53+20)/8),(Reg[4]&0x1f)*0x800+(line_cnt-16-53+20)%8+tmp1*8);
    if ((Reg[1]&0x40)==0) tmp=0;// Blank screen
    set_color(time,tmp&mask[((clk_cnt-100)/2)%6],Reg[7]);
   } else    set_color(time,0,Reg[7]);
//===================================================
   if (clk_cnt==100) pin_HRTC->setstate(0,1,SHI);
   if (clk_cnt==1368) clk_cnt=0; else clk_cnt++;
   if (line_cnt==0) pin_VRTC->setstate(0,1,SLO);
   if (line_cnt==3) pin_VRTC->setstate(0,1,SHI);
   if (line_cnt==(192+3+13+53-20+(Reg[9]/128)*20))  //192 or 212 lines
   {
     SReg[0]|=0x80;//Set INT flag
     if (Reg[1]&0x20) pin_INT->setstate(0,1,SLO);
     SReg[2]|=0x40;//Set vertical retrace flag
   }
   if (cpuclk_cnt==0) pin_CPUCLK->setstate(0,1,SLO);
   if (cpuclk_cnt==3) pin_CPUCLK->setstate(0,1,SHI);
   if (cpuclk_cnt==5) cpuclk_cnt=0; else cpuclk_cnt++;
//===================================================
  }//end if (pin_CLK->isnegedge())
  
  if (pin_CLK->isposedge()) 
  {
   if (dclk_cnt&0x01) pin_DHCLK->setstate(0,1,SHI); else pin_DHCLK->setstate(0,1,SLO);
   if (dclk_cnt&0x02) pin_DLCLK->setstate(0,1,SHI); else pin_DLCLK->setstate(0,1,SLO);
   dclk_cnt++;
  }

  if (pin_nWR->isnegedge())
  {
   tmp=0;
   if (pin_MODE0->isactive()) tmp++;
   if (pin_MODE1->isactive()) tmp+=2;
   switch(tmp)
   {
   case 0:
    {
    takt=0;
      VRAM[VRAM_ptr]=get_data();
      //if ((VRAM_ptr&0x3fff)==0x3fff) Reg[14]=(Reg[14]+1)&0x07;
      VRAM_ptr++;
      break;
    }
   case 1:     //write to PORT 01
    {
     if (takt==0) //first write
     {
      takt=1;
      T0tmp=get_data();
// instance->log("write RegSetup PORT_1 T0 %x",T0tmp);
     }
     else //second write
     {
      takt=0;
      T1tmp=get_data();
//instance->log("write RegSetup PORT_1 T1 %x",T1tmp);
//if ((T1tmp&0xc0)==0x80){ if ((T1tmp&0x3f)>0x10) {if ((T1tmp&0x3f)==45) instance->log("write Reg(%d) = %x =======================",T1tmp&0x3f,T0tmp);else instance->log("write Reg(%d) = %x",T1tmp&0x3f,T0tmp);}}
      if ((T1tmp&0xc0)==0x80) 
      {
      if ((T1tmp&0x3f)==0x10) Reg[0x10]=T0tmp*2; else { Reg[T1tmp&0x3f]=T0tmp; if ((T1tmp&0x3f)==46) Process_command();}
      if ((T1tmp&0x3f)<2)
       {
       T0tmp=video_mode;
       video_mode=0;
        if (Reg[1]&0x10) video_mode|=0x01;//M1
        if (Reg[1]&0x08) video_mode|=0x02;//M2
        if (Reg[0]&0x02) video_mode|=0x04;//M3
        if (Reg[0]&0x04) video_mode|=0x08;//M4
        if (Reg[0]&0x08) video_mode|=0x10;//M5
       if (video_mode!=T0tmp) print_mode(video_mode);
       }
       if (((Reg[17]&0x3f)==44)&((Reg[46]&0xf0)==0xb0)) {Process_B0_cmd(); /*instance->log("! Reg[46]==0xb0 and write Reg[44]=%x",T1tmp);*/}
      }
      else //set VRAM pointer addr
       {if ((T1tmp&0x80)==0) {VRAM_ptr=T0tmp;VRAM_ptr+=(T1tmp&0x3f)*256;VRAM_ptr+=(Reg[14]&0x07)*0x4000; }}
     }
   break;
    }//end if write to PORT 01
   case 2:
    {
     T0tmp=get_data();
     Palette[Reg[0x10]&0x1f]=T0tmp;
 //instance->log("write palette PORT_2 Palette[%d]=%x",Reg[0x10],T0tmp);
     Reg[0x10]=(Reg[0x10]+1)&0x1f;
     break;
    }
   case 3:
    {
      T0tmp=get_data();
// instance->log("indirect write PORT_3 - Reg[%d]= %x",Reg[17]&0x3f,T0tmp);
      if ((Reg[17]&0x3f)!=17) Reg[Reg[17]&0x3f]=T0tmp;
    if (Reg[17]==46) { /*instance->log("indir write Reg(46) = %x",T0tmp);*/ Process_command();}
      if ((Reg[17]&0x80)==0) { Reg[17]++; Reg[17]=Reg[17]&0x3f; }
      if (((Reg[17]&0x3f)==44)&((Reg[46]&0xf0)==0xb0)) Process_B0_cmd();
    break;
    }
   }//end switch(tmp)
  }// end if (pin_nWR->isnegedge())

  if (pin_nRD->isnegedge())
  {
   if (pin_MODE0->isactive()) tmp=1; else tmp=0;
   if (pin_MODE1->isactive()) tmp+=2;
   if (tmp==0) //read VRAM Data
   {
    takt=0;
// instance->log("read VRAM Data[%x] %x",VRAM_ptr,VRAM[VRAM_ptr]);
      set_data(time,VRAM[VRAM_ptr]);
      //if ((VRAM_ptr&0x3fff)==0x3fff) Reg[14]=(Reg[14]+1)&0x07;
      VRAM_ptr++;
   }
   if (tmp==1) //read Status Reg
   {
// instance->log("read Status Reg");
      set_data(time,SReg[Reg[15]&0x0f]);
     if ((Reg[15]&0x0f)==0) SReg[0]&=~0x80;//Reset INT flag
     pin_INT->setstate(0,1,SHI);

   }
  }//end if (pin_nRD->isnegedge())

  if (pin_nRD->isposedge()) set_data_Z(time);
}   
       
      
void V9938::callback(ABSTIME time,EVENTID eventid)   {   

}   
              
extern "C" IACTIVEMODEL __declspec(dllexport)*createactivemodel(CHAR *device,ILICENCESERVER *ils)  {    
        ils->authorize (0);     
        return new V9938;
}   
              
extern "C" VOID  __declspec(dllexport)deleteactivemodel (IACTIVEMODEL *model)  {    
  delete (V9938*)model;   
}   
               
void V9938::initialize(ICOMPONENT *cpt)  {    

}   
               
ISPICEMODEL *V9938::getspicemodel(CHAR *)  {    
        return NULL;    
}   
       
IDSIMMODEL  *V9938::getdsimmodel(CHAR *)  {      
        return this;    
}   

void V9938::plot(ACTIVESTATE state)  {   

//  MessageBox(0, "plot", "Break", MB_OK);
}
        
void V9938::animate(INT element, ACTIVEDATA *data)  {    
//  MessageBox(0, "animate", "Break", MB_OK);

}   

BOOL V9938::actuate(WORD key, INT x, INT y, DWORD flags)  {
//  MessageBox(0, "ACTUATE2", "Break", MB_OK);
        return FALSE;    
}  
